@GlobalQuantifyCapability(r'\.Color$', Model)
import 'package:reflectable/reflectable.dart';

class ModelAnnotation extends Reflectable {
  const ModelAnnotation()
      : super(
          invokingCapability,
          declarationsCapability,
          reflectedTypeCapability,
          metadataCapability,
          typeRelationsCapability,
        );
}

const Model = const ModelAnnotation();
const Reflection = const ModelAnnotation();

@Model
class Key {
  final bool auto;

  const Key({this.auto = false});
}

//@Reflection
//class Required2 {
//  final String msg;
//
//  const Required2({this.msg = ''});
//}

@Reflection
class Check {
  final validations;

  const Check(this.validations);
}
