import 'dart:io';

import 'package:progress_dialog/progress_dialog.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:workmanager/workmanager.dart';

import 'DatabaseHelper.dart';
import 'GlobalScopeRF.dart';
import 'SystemRF.dart';

Future<int> _readCount() async {
  var prefs = await SharedPreferences.getInstance();
  return prefs.getInt('Counter.count') ?? 0;
}

Future<void> _writeCount(int count) async {
  var prefs = await SharedPreferences.getInstance();
  return prefs.setInt('Counter.count', count);
}

void callbackDispatcher() {
  Workmanager.executeTask((task, inputData) async {
//    ProgressDialog pr;
//    pr = ProgressDialog(
//      Libs.context,
//      type: ProgressDialogType.Download,
//      isDismissible: true,
//    );
//    await pr.show();
//    sleep(Duration(seconds: 5));
//    await pr.hide();
    await go();
    return Future.value(true);
  });
}

void go() async {

  final dbHelper = DatabaseHelper.instance;

  for (int i = 0; i < 10; i++) {
    sleep(Duration(seconds: 5));
//    DateTime timestamp = DateTime.now();
//    String time = DateTime.now().toString();
//    print(time);
//    //-----------DB Operation-------------------
//    Map<String, dynamic> row = {
//      DatabaseHelper.columnName: 'Bob' + i.toString(),
//      DatabaseHelper.columnAge: 23
//    };
//    final id = await dbHelper.insert(row);
//    print('inserted row id: $id');
//    final allRows = await dbHelper.queryAllRows();
//    print('query all rows:');
//
//    allRows.forEach((row) {
//      print(row);
//    });
//
//    await _writeCount(allRows.length);
//    int m = await _readCount();
int m=0;
    SystemRF.notification.notify(NotifyRF(title: m.toString(), description: 'time'));
  }
}
