import 'package:flutter/material.dart';

class RestartRF extends StatefulWidget {
  RestartRF(this.child);

  final Widget child;

  static void restartApp(BuildContext context) {
    var d= context.findAncestorStateOfType<_RestartRFState>();
    context.findAncestorStateOfType<_RestartRFState>().restartApp();
  }

  @override
  _RestartRFState createState() => _RestartRFState();
}

class _RestartRFState extends State<RestartRF> {
  Key key = UniqueKey();

  void restartApp() {
    setState(() {
      key = UniqueKey();
    });
  }

  @override
  Widget build(BuildContext context) {
    return KeyedSubtree(
      key: key,
      child: widget.child,
    );
  }
}