import 'package:rapidfire/uiux/WidgetsRF.dart';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../../../SystemRF.dart';

class ForgetPass extends StatefulWidget {
  ForgetPass({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _ForgetPassState createState() => _ForgetPassState();
}

class _ForgetPassState extends State<ForgetPass> {
  TextEditingController a = TextEditingController();
  TextEditingController b = TextEditingController();
  TextEditingController c = TextEditingController();
  TextEditingController d = TextEditingController();

  @override
  Widget build(BuildContext context) {
    final height = MediaQuery.of(context).size.height;
    return WillPopScope(
      onWillPop: () {
        Navigator.pop(context);
      },
      child: Scaffold(
        resizeToAvoidBottomInset: false,
        body: Container(color: Colors.white,
          padding: EdgeInsets.symmetric(horizontal: 20),
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisAlignment: MainAxisAlignment.start,
            children: <Widget>[
              SizedBox(
                height: 40
              ),
              Container(
                  margin: EdgeInsets.all(10),
                  child: Image.asset(
                    "assets/images/forgot_pass.webp",
                    height: 250,
                  )),
              Text(
                "Enter Registered Mobile",
                style: TextStyle(fontSize: 20),
              ),
              SizedBox(height: 50),
              Container(
                width: 300,
                height: 50,
                padding: EdgeInsets.only(right: 3, left: 3),
                decoration: BoxDecoration(
                  //                  boxShadow: [
//                    BoxShadow(
//                      color: Colors.grey.withOpacity(0.5),
//                      spreadRadius: 5,
//                      blurRadius: 7,
//                      offset: Offset(0, 3), // changes position of shadow
//                    ),
//                  ],
                  border: Border.all(color: Colors.pink),
                  borderRadius: BorderRadius.all(Radius.circular(0)),
                  color: Colors.white,
                ),
                child: TextField(
                    controller: a,
                    maxLength: 11,
                    textAlign: TextAlign.center,
                    keyboardType: TextInputType.number,
                    style: TextStyle(fontSize: 20),
                    onChanged: (_) {
                      if (a.text.length == 11) FocusScope.of(context).unfocus();
                    },
                    decoration: InputDecoration(
                      counterText: '',
                      border: InputBorder.none,
                      fillColor: Colors.transparent,
                    )),
              ),
              SizedBox(height: 30),
              Text(
                "Newly generated password will be sent to your registered number soon.",
                style: TextStyle(fontSize: 15, color: Colors.grey),
                textAlign: TextAlign.center,
              ),
              SizedBox(height: 80),
              ButtonRF(
                color: Colors.pink,
                buttonType: ButtonType.raised,
                buttonStyle: ButtonStyleRF.submit,
                textColor: Colors.white,
                text: Text(
                  "Confirm",
                  style: TextStyle(fontSize: 18),
                ),
                borderRadious: 50,
                elevation: 0,
                width: 200,
                height: 50,
                onTap: () async {},
              ),
              SizedBox(height: 30),
            ],
          ),
        ),
      ),
    );
  }
}
