//#region FieldRowRF
import 'package:flutter/material.dart';

class FieldRowRF extends StatefulWidget {
  const FieldRowRF(this.controls, [this.flex, this.x = 25, this.y = 10]);

  final dynamic controls;
  final double x;
  final double y;
  final List<int> flex;

  @override
  _FieldRowRF createState() => _FieldRowRF();
}

class _FieldRowRF extends State<FieldRowRF> {
  @override
  Widget build(BuildContext context) {
    int count = 1;
    var widgets = List<Widget>();

    for (var item in widget.controls) {
      var _flex;
      if (widget.flex != null) {
        _flex = widget?.flex[count - 1];
      }
      var ctl = Expanded(child: item, flex: _flex ?? 100);
      //print(_flex.toString());
      widgets.add(ctl);
      if (widget.controls.length != count) widgets.add(SizedBox(width: widget.y));
      count++;
    }
    if (widget.x != 0) {
      widgets.add(Container(
        height: widget.x,
      ));
    }

    return Row(
      mainAxisAlignment: MainAxisAlignment.end,
      //mainAxisAlignment: MainAxisAlignment.start,
      mainAxisSize: MainAxisSize.max,
      crossAxisAlignment: CrossAxisAlignment.start,
      children: widgets,
    );
  }
}
//#endregion RowRF