import 'dart:io';

import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';

import 'GlobalRF.dart';
import 'BGSyncSMain.dart';
import 'SystemRF.dart';
import 'BackgroundMain.dart';

class JobRF {
  bool isBusy = false;
  Function job;
  Duration duration;
  Function onComplete;

  JobRF(this.job, {this.duration, this.onComplete}) {
    if (duration == null) {
      job.call();
    } else {
      if (!isBusy) {
        isBusy = true;
        Stream.periodic(Duration(seconds: 1)).listen((_) {
          //_counter.increment();
          job.call();
          sleep(duration);
          // _counter.updateComplete();
          if (onComplete != null) onComplete.call();
        });
        isBusy = false;
      }
    }
  }
}

class JobRF1 {
  String name;
  int period;
  dynamic job;

  JobRF1({this.name, this.period, this.job});

  sync() {
  //  SystemRF.job.register(JobRF1(name: 'myJob', period: null, job: syncDispatcher));
  }
}
