import 'package:rapidfire/Api.dart';
import 'Dynamic.dart';
import 'Annotation.dart' as annotation;

class Rdb {
  Api api = Api();

  get(Object model, String sql, List<dynamic> values, int pageNo, Function onComplete) async {
    return await api.remoteGet(model, pageNo, onComplete);
  }

  save(Object model, [Function onSuccess]) async {
    var command = '';
    var pk = Dynamic(model).annotationData(annotation.Key);
    var value = Dynamic(model).get(pk.first['field']);
    if (value == null)
      command = 'add';
    else
      command = 'update';

    var result = await api.remoteSave(model, command, onSuccess);
    return result;
  }

  delete(Object model, String id, [Function onSuccess]) {
    api.remoteDelete(model, onSuccess);
  }
}
