import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:rapidfire/Config.dart';
import 'package:rapidfire/uiux/DrawerRF.dart';
import '../../../Annotation.dart';
import '../../../GlobalScopeRF.dart';
import '../../StoreRF.dart';
import '../../../uiux/WidgetsRF.dart';
import 'package:rapidfire/uiux/StyleRF.dart';

class HomeRF extends StatefulWidget {
  IStoryboardRF storyboard;

  //  FlexBarRF flex;
//  List<Widget> actions;
//  DrawerItemRF drawerItems;
//  DrawerItemRF drawerFooter; //all these paramiter might go to StroryboardRF
  //ThemeRF theme;

  @override
  _HomeRFState createState() => _HomeRFState();

  HomeRF({this.storyboard});
}

class _HomeRFState extends State<HomeRF> {
  @override
  Widget build(BuildContext context) {
    var board = widget.storyboard.customStoryboard(context);
    //(widget.storyboard as IStoryboardRF).customStoryboard(context);
    //board.outline = PageOutlineRF();

    return DrawerRF(
      menuHeader: StoreRF.scaffold(template: TemplateRF.get())
          .outline
          .storeOutline()
          .header
          .drawer
          .drawerHeader(Libs.config.app.title, Libs.config.app.subTitle, '', null), //Dummy Replace
      //menuBody:
      //board.drawerItems ?? StoreRF.scaffold(TemplateRF.get()).outline.drawerBodyItems(context, TemplateRF.get()),
      //  menuFooter:
      //    board.drawerFooter ?? StoreRF.scaffold(TemplateRF.get()).outline.drawerFooter(context, TemplateRF.get()),
      pageBuilder: (onTap) {
        //  board.outline?.leading = StoreRF.scaffold(TemplateRF.get()).outline.drawerMenuButton(onTap);

//        board.outline?.actions = board.outline.actions ??
//            WidgetsRF
//                .stockOfUI(TemplateRF.get())
//                .pageOutline
//                .pageToolBar(() {});

        return PageRF(
          title: board.title,
          outline: board.outline,
          flex: board.flex,
          stickyHeader: board.stickyHeader,
          fab: board.fab,
          model: board.model,
          osBarColors: board.osBarColors,
          body: Container(child: board.child), //????
        );
      },
    );
  }
}

//    book.name = 'imrose';
//    book.age = 20;
//    var xyx = book.changed;

//var v123 = book.changed;

//book.changed == true
//? WidgetsRF.validatedPop(context)
//: Navigator.of(context).pop(true);

class MyRF extends StatefulWidget {
  @override
  _MyRFState createState() => _MyRFState();
}

class _MyRFState extends State<MyRF> {
  @override
  Widget build(BuildContext context) {
    return PageRF(
      title: 'My App',
      body: Text('My App Text'),
    );
  }
}
