import 'dart:io';
import 'dart:async';

import 'package:flutter/foundation.dart';

import 'counter.dart';
import 'package:shared_preferences/shared_preferences.dart';

class CounterService {
  factory CounterService() => _instance;

  CounterService._internal();

  static final _instance = CounterService._internal();

  final _counter = Counter();

  ValueListenable<int> count() {
    return _counter.count();
  }

  void init() {
    _counter.increment();
  }

//  void write(int i) {
//    _counter.writeCount(i);
//  }
//
//  read() async {
//    return await _counter.readCount();
//  }

  void startCounting() {
    Stream.periodic(Duration(seconds: 1)).listen((_) {
      _counter.increment();
      print('Counter incremented from Exmaple: ${_counter.count().value}');
    });
  }

  void startCounting1() {
//    Stream.periodic(Duration(seconds: 2)).listen((_) async {
//      //_counter.increment();
//      var ret = await _counter.readCount();
//      if (ret == 1) {
//        _counter.increment(); //Signal
//        await _counter.writeCount(-1);
//        print('job done');
//      }
//      print('Counter incremented Git: ${_counter.count().value}');
//    });
  }

  void aService() {
//    Stream.periodic(Duration(seconds: 1)).listen((_) async {
//      var ret = await CounterService().read();
//      if (ret >= 0) {
//        print('a service');
//        sleep(Duration(seconds: 20));
//        await CounterService().write(1);
//      }
//    });
  }
}
